// Generated by pmgen.py from passes/pmgen/ice40_dsp.pmg

struct ice40_dsp_pm {
  Module *module;
  SigMap sigmap;
  std::function<void()> on_accept;

  typedef std::tuple<> index_0_key_type;
  dict<index_0_key_type, vector<Cell*>> index_0;
  typedef std::tuple<SigSpec> index_1_key_type;
  dict<index_1_key_type, vector<Cell*>> index_1;
  typedef std::tuple<SigSpec> index_3_key_type;
  dict<index_3_key_type, vector<Cell*>> index_3;
  typedef std::tuple<SigSpec> index_5_key_type;
  dict<index_5_key_type, vector<Cell*>> index_5;
  typedef std::tuple<SigSpec> index_7_key_type;
  dict<index_7_key_type, vector<Cell*>> index_7;
  typedef std::tuple<SigSpec> index_8_key_type;
  dict<index_8_key_type, vector<Cell*>> index_8;
  typedef std::tuple<SigSpec> index_10_key_type;
  dict<index_10_key_type, vector<Cell*>> index_10;
  typedef std::tuple<SigSpec> index_11_key_type;
  dict<index_11_key_type, vector<Cell*>> index_11;
  typedef std::tuple<SigSpec, SigSpec> index_13_key_type;
  dict<index_13_key_type, vector<Cell*>> index_13;
  dict<SigBit, pool<Cell*>> sigusers;
  pool<Cell*> blacklist_cells;
  pool<Cell*> autoremove_cells;
  bool blacklist_dirty;
  int rollback;

  struct state_ice40_dsp_t {
    Cell* addA;
    Cell* addAB;
    Cell* addB;
    SigBit clock;
    bool clock_pol;
    bool clock_vld;
    Cell* ffA;
    Cell* ffB;
    Cell* ffS;
    Cell* ffY;
    Cell* mul;
    Cell* muxA;
    Cell* muxAB;
    Cell* muxB;
    SigSpec sigA;
    SigSpec sigB;
    SigSpec sigS;
    SigSpec sigY;
  } st_ice40_dsp;

  struct udata_ice40_dsp_t {
  } ud_ice40_dsp;

  IdString id_b_A{"\\A"};
  IdString id_b_A_SIGNED{"\\A_SIGNED"};
  IdString id_b_B{"\\B"};
  IdString id_b_CLK{"\\CLK"};
  IdString id_b_CLK_POLARITY{"\\CLK_POLARITY"};
  IdString id_b_D{"\\D"};
  IdString id_b_Q{"\\Q"};
  IdString id_b_Y{"\\Y"};
  IdString id_d_add{"$add"};
  IdString id_d_dff{"$dff"};
  IdString id_d_mul{"$mul"};
  IdString id_d_mux{"$mux"};
  IdString id_d_sub{"$sub"};

  void add_siguser(const SigSpec &sig, Cell *cell) {
    for (auto bit : sigmap(sig)) {
      if (bit.wire == nullptr) continue;
      if (sigusers.count(bit) == 0 && bit.wire->port_id)
        sigusers[bit].insert(nullptr);
      sigusers[bit].insert(cell);
    }
  }

  void blacklist(Cell *cell) {
    if (cell != nullptr) {
      if (blacklist_cells.insert(cell).second)
        blacklist_dirty = true;
    }
  }

  void autoremove(Cell *cell) {
    if (cell != nullptr) {
      if (blacklist_cells.insert(cell).second)
        blacklist_dirty = true;
      autoremove_cells.insert(cell);
    }
  }

  void check_blacklist_ice40_dsp() {
    if (!blacklist_dirty)
      return;
    blacklist_dirty = false;
    if (st_ice40_dsp.mul != nullptr && blacklist_cells.count(st_ice40_dsp.mul)) {
      rollback = 1;
      return;
    }
    if (st_ice40_dsp.ffA != nullptr && blacklist_cells.count(st_ice40_dsp.ffA)) {
      rollback = 2;
      return;
    }
    if (st_ice40_dsp.ffB != nullptr && blacklist_cells.count(st_ice40_dsp.ffB)) {
      rollback = 4;
      return;
    }
    if (st_ice40_dsp.ffY != nullptr && blacklist_cells.count(st_ice40_dsp.ffY)) {
      rollback = 6;
      return;
    }
    if (st_ice40_dsp.addA != nullptr && blacklist_cells.count(st_ice40_dsp.addA)) {
      rollback = 8;
      return;
    }
    if (st_ice40_dsp.addB != nullptr && blacklist_cells.count(st_ice40_dsp.addB)) {
      rollback = 9;
      return;
    }
    if (st_ice40_dsp.muxA != nullptr && blacklist_cells.count(st_ice40_dsp.muxA)) {
      rollback = 11;
      return;
    }
    if (st_ice40_dsp.muxB != nullptr && blacklist_cells.count(st_ice40_dsp.muxB)) {
      rollback = 12;
      return;
    }
    if (st_ice40_dsp.ffS != nullptr && blacklist_cells.count(st_ice40_dsp.ffS)) {
      rollback = 14;
      return;
    }
    rollback = 0;
  }

  SigSpec port(Cell *cell, IdString portname) {
    return sigmap(cell->getPort(portname));
  }

  Const param(Cell *cell, IdString paramname) {
    return cell->getParam(paramname);
  }

  int nusers(const SigSpec &sig) {
    pool<Cell*> users;
    for (auto bit : sigmap(sig))
      for (auto user : sigusers[bit])
        users.insert(user);
    return GetSize(users);
  }

  ice40_dsp_pm(Module *module, const vector<Cell*> &cells) :
      module(module), sigmap(module) {
    for (auto cell : module->cells()) {
      for (auto &conn : cell->connections())
        add_siguser(conn.second, cell);
    }
    for (auto cell : cells) {
      do {
        Cell *mul = cell;
        if (!(mul->type.in(id_d_mul))) break;
        if (!(GetSize(mul->getPort(id_b_A)) + GetSize(mul->getPort(id_b_B)) > 10)) break;
        if (!(GetSize(mul->getPort(id_b_Y)) > 10)) break;
        index_0_key_type key;
        index_0[key].push_back(cell);
      } while (0);
      do {
        Cell *ffA = cell;
        if (!(ffA->type.in(id_d_dff))) break;
        index_1_key_type key;
        std::get<0>(key) = port(ffA, id_b_Q);
        index_1[key].push_back(cell);
      } while (0);
      do {
        Cell *ffB = cell;
        if (!(ffB->type.in(id_d_dff))) break;
        index_3_key_type key;
        std::get<0>(key) = port(ffB, id_b_Q);
        index_3[key].push_back(cell);
      } while (0);
      do {
        Cell *ffY = cell;
        if (!(ffY->type.in(id_d_dff))) break;
        if (!(nusers(port(ffY, id_b_D)) == 2)) break;
        index_5_key_type key;
        std::get<0>(key) = port(ffY, id_b_D);
        index_5[key].push_back(cell);
      } while (0);
      do {
        Cell *addA = cell;
        if (!(addA->type.in(id_d_add))) break;
        if (!(nusers(port(addA, id_b_A)) == 2)) break;
        index_7_key_type key;
        std::get<0>(key) = port(addA, id_b_A);
        index_7[key].push_back(cell);
      } while (0);
      do {
        Cell *addB = cell;
        if (!(addB->type.in(id_d_add, id_d_sub))) break;
        if (!(nusers(port(addB, id_b_B)) == 2)) break;
        index_8_key_type key;
        std::get<0>(key) = port(addB, id_b_B);
        index_8[key].push_back(cell);
      } while (0);
      do {
        Cell *muxA = cell;
        if (!(muxA->type.in(id_d_mux))) break;
        if (!(nusers(port(muxA, id_b_A)) == 2)) break;
        index_10_key_type key;
        std::get<0>(key) = port(muxA, id_b_A);
        index_10[key].push_back(cell);
      } while (0);
      do {
        Cell *muxB = cell;
        if (!(muxB->type.in(id_d_mux))) break;
        if (!(nusers(port(muxB, id_b_B)) == 2)) break;
        index_11_key_type key;
        std::get<0>(key) = port(muxB, id_b_B);
        index_11[key].push_back(cell);
      } while (0);
      do {
        Cell *ffS = cell;
        if (!(ffS->type.in(id_d_dff))) break;
        if (!(nusers(port(ffS, id_b_D)) == 2)) break;
        index_13_key_type key;
        std::get<0>(key) = port(ffS, id_b_D);
        std::get<1>(key) = port(ffS, id_b_Q);
        index_13[key].push_back(cell);
      } while (0);
    }
  }

  ~ice40_dsp_pm() {
    for (auto cell : autoremove_cells)
      module->remove(cell);
  }

  void run_ice40_dsp(std::function<void()> on_accept_f) {
    on_accept = on_accept_f;
    rollback = 0;
    blacklist_dirty = false;
    st_ice40_dsp.addA = nullptr;
    st_ice40_dsp.addAB = nullptr;
    st_ice40_dsp.addB = nullptr;
    st_ice40_dsp.clock = SigBit();
    st_ice40_dsp.clock_pol = bool();
    st_ice40_dsp.clock_vld = bool();
    st_ice40_dsp.ffA = nullptr;
    st_ice40_dsp.ffB = nullptr;
    st_ice40_dsp.ffS = nullptr;
    st_ice40_dsp.ffY = nullptr;
    st_ice40_dsp.mul = nullptr;
    st_ice40_dsp.muxA = nullptr;
    st_ice40_dsp.muxAB = nullptr;
    st_ice40_dsp.muxB = nullptr;
    st_ice40_dsp.sigA = SigSpec();
    st_ice40_dsp.sigB = SigSpec();
    st_ice40_dsp.sigS = SigSpec();
    st_ice40_dsp.sigY = SigSpec();
    block_0();
  }

  void run_ice40_dsp(std::function<void(ice40_dsp_pm&)> on_accept_f) {
    run_ice40_dsp([&](){on_accept_f(*this);});
  }

  void run_ice40_dsp(std::function<void(state_ice40_dsp_t&)> on_accept_f) {
    run_ice40_dsp([&](){on_accept_f(st_ice40_dsp);});
  }

  void run_ice40_dsp() {
    run_ice40_dsp([](){});
  }

  void block_0() {
    Cell* &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;

    index_0_key_type key;
    const vector<Cell*> &cells = index_0[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      mul = cells[idx];
      if (blacklist_cells.count(mul)) continue;
      block_1();
      if (rollback) {
        if (rollback != 1) {
          mul = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    mul = nullptr;
  }

  void block_1() {
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    Cell* &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;

    index_1_key_type key;
    std::get<0>(key) = port(mul, id_b_A);
    const vector<Cell*> &cells = index_1[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      ffA = cells[idx];
      if (blacklist_cells.count(ffA)) continue;
      block_2();
      if (rollback) {
        if (rollback != 2) {
          ffA = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    ffA = nullptr;
    block_2();
  }

  void block_2() {
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;

    do {
#define reject do { check_blacklist_ice40_dsp(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_ice40_dsp(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_3(); if (rollback) goto rollback_label; } while(0)
      sigA = port(mul, id_b_A);
      if (ffA) {
        sigA = port(ffA, id_b_D);
        clock = port(ffA, id_b_CLK).as_bit();
        clock_pol = param(ffA, id_b_CLK_POLARITY).as_bool();
        clock_vld = true;
      }

      block_3();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    clock = SigBit();
    clock_pol = bool();
    clock_vld = bool();
    sigA = SigSpec();
  }

  void block_3() {
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    Cell* &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;

    index_3_key_type key;
    std::get<0>(key) = port(mul, id_b_B);
    const vector<Cell*> &cells = index_3[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      ffB = cells[idx];
      if (blacklist_cells.count(ffB)) continue;
      block_4();
      if (rollback) {
        if (rollback != 4) {
          ffB = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    ffB = nullptr;
    block_4();
  }

  void block_4() {
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;

    SigBit backup_clock = clock;
    bool backup_clock_pol = clock_pol;
    bool backup_clock_vld = clock_vld;

    do {
#define reject do { check_blacklist_ice40_dsp(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_ice40_dsp(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_5(); if (rollback) goto rollback_label; } while(0)
      sigB = port(mul, id_b_B);
      if (ffB) {
        sigB = port(ffB, id_b_D);
        SigBit c = port(ffB, id_b_CLK).as_bit();
        bool cp = param(ffB, id_b_CLK_POLARITY).as_bool();
        if (clock_vld && (c != clock || cp != clock_pol))
          reject;
        clock = c;
        clock_pol = cp;
        clock_vld = true;
      }

      block_5();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    clock = backup_clock;
    clock_pol = backup_clock_pol;
    clock_vld = backup_clock_vld;
    sigB = SigSpec();
  }

  void block_5() {
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    Cell* &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;

    index_5_key_type key;
    std::get<0>(key) = port(mul, id_b_Y);
    const vector<Cell*> &cells = index_5[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      ffY = cells[idx];
      if (blacklist_cells.count(ffY)) continue;
      block_6();
      if (rollback) {
        if (rollback != 6) {
          ffY = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    ffY = nullptr;
    block_6();
  }

  void block_6() {
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;

    SigBit backup_clock = clock;
    bool backup_clock_pol = clock_pol;
    bool backup_clock_vld = clock_vld;

    do {
#define reject do { check_blacklist_ice40_dsp(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_ice40_dsp(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_7(); if (rollback) goto rollback_label; } while(0)
      sigY = port(mul, id_b_Y);
      if (ffY) {
        sigY = port(ffY, id_b_Q);
        SigBit c = port(ffY, id_b_CLK).as_bit();
        bool cp = param(ffY, id_b_CLK_POLARITY).as_bool();
        if (clock_vld && (c != clock || cp != clock_pol))
          reject;
        clock = c;
        clock_pol = cp;
        clock_vld = true;
      }

      block_7();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    clock = backup_clock;
    clock_pol = backup_clock_pol;
    clock_vld = backup_clock_vld;
    sigY = SigSpec();
  }

  void block_7() {
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;

    index_7_key_type key;
    std::get<0>(key) = sigY;
    const vector<Cell*> &cells = index_7[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      addA = cells[idx];
      if (blacklist_cells.count(addA)) continue;
      block_8();
      if (rollback) {
        if (rollback != 8) {
          addA = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    addA = nullptr;
    block_8();
  }

  void block_8() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;

    if (!(!addA)) {
      addB = nullptr;
      block_9();
      return;
    }

    index_8_key_type key;
    std::get<0>(key) = sigY;
    const vector<Cell*> &cells = index_8[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      addB = cells[idx];
      if (blacklist_cells.count(addB)) continue;
      block_9();
      if (rollback) {
        if (rollback != 9) {
          addB = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    addB = nullptr;
    block_9();
  }

  void block_9() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    Cell* const &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &addAB YS_ATTRIBUTE(unused) = st_ice40_dsp.addAB;
    SigSpec &sigS YS_ATTRIBUTE(unused) = st_ice40_dsp.sigS;

    do {
#define reject do { check_blacklist_ice40_dsp(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_ice40_dsp(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_10(); if (rollback) goto rollback_label; } while(0)
      if (addA) {
        addAB = addA;
        sigS = port(addA, id_b_B);
      }
      if (addB) {
        addAB = addB;
        sigS = port(addB, id_b_A);
      }
      if (addAB) {
        int natural_mul_width = GetSize(sigA) + GetSize(sigB);
        int actual_mul_width = GetSize(sigY);
        int actual_acc_width = GetSize(sigS);
        if ((actual_acc_width > actual_mul_width) && (natural_mul_width > actual_mul_width))
          reject;
        if ((actual_acc_width != actual_mul_width) && (param(mul, id_b_A_SIGNED).as_bool() != param(addAB, id_b_A_SIGNED).as_bool()))
          reject;
      }

      block_10();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    addAB = nullptr;
    sigS = SigSpec();
  }

  void block_10() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    Cell* const &addAB YS_ATTRIBUTE(unused) = st_ice40_dsp.addAB;
    Cell* const &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigS YS_ATTRIBUTE(unused) = st_ice40_dsp.sigS;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &muxA YS_ATTRIBUTE(unused) = st_ice40_dsp.muxA;

    if (!(addAB)) {
      muxA = nullptr;
      block_11();
      return;
    }

    index_10_key_type key;
    std::get<0>(key) = port(addAB, id_b_Y);
    const vector<Cell*> &cells = index_10[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      muxA = cells[idx];
      if (blacklist_cells.count(muxA)) continue;
      block_11();
      if (rollback) {
        if (rollback != 11) {
          muxA = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    muxA = nullptr;
    block_11();
  }

  void block_11() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    Cell* const &addAB YS_ATTRIBUTE(unused) = st_ice40_dsp.addAB;
    Cell* const &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    Cell* const &muxA YS_ATTRIBUTE(unused) = st_ice40_dsp.muxA;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigS YS_ATTRIBUTE(unused) = st_ice40_dsp.sigS;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &muxB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxB;

    if (!(addAB)) {
      muxB = nullptr;
      block_12();
      return;
    }

    if (!(!muxA)) {
      muxB = nullptr;
      block_12();
      return;
    }

    index_11_key_type key;
    std::get<0>(key) = port(addAB, id_b_Y);
    const vector<Cell*> &cells = index_11[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      muxB = cells[idx];
      if (blacklist_cells.count(muxB)) continue;
      block_12();
      if (rollback) {
        if (rollback != 12) {
          muxB = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    muxB = nullptr;
    block_12();
  }

  void block_12() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    Cell* const &addAB YS_ATTRIBUTE(unused) = st_ice40_dsp.addAB;
    Cell* const &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    Cell* const &muxA YS_ATTRIBUTE(unused) = st_ice40_dsp.muxA;
    Cell* const &muxB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxB;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigS YS_ATTRIBUTE(unused) = st_ice40_dsp.sigS;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &muxAB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxAB;

    do {
#define reject do { check_blacklist_ice40_dsp(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_ice40_dsp(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_13(); if (rollback) goto rollback_label; } while(0)
      muxAB = addAB;
      if (muxA)
        muxAB = muxA;
      if (muxB)
        muxAB = muxB;

      block_13();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    muxAB = nullptr;
  }

  void block_13() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    Cell* const &addAB YS_ATTRIBUTE(unused) = st_ice40_dsp.addAB;
    Cell* const &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;
    const SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    const bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    const bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    Cell* const &muxA YS_ATTRIBUTE(unused) = st_ice40_dsp.muxA;
    Cell* const &muxAB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxAB;
    Cell* const &muxB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxB;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigS YS_ATTRIBUTE(unused) = st_ice40_dsp.sigS;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    Cell* &ffS YS_ATTRIBUTE(unused) = st_ice40_dsp.ffS;

    if (!(muxAB)) {
      ffS = nullptr;
      block_14();
      return;
    }

    index_13_key_type key;
    std::get<0>(key) = port(muxAB, id_b_Y);
    std::get<1>(key) = sigS;
    const vector<Cell*> &cells = index_13[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      ffS = cells[idx];
      if (blacklist_cells.count(ffS)) continue;
      block_14();
      if (rollback) {
        if (rollback != 14) {
          ffS = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    ffS = nullptr;
  }

  void block_14() {
    Cell* const &addA YS_ATTRIBUTE(unused) = st_ice40_dsp.addA;
    Cell* const &addAB YS_ATTRIBUTE(unused) = st_ice40_dsp.addAB;
    Cell* const &addB YS_ATTRIBUTE(unused) = st_ice40_dsp.addB;
    Cell* const &ffA YS_ATTRIBUTE(unused) = st_ice40_dsp.ffA;
    Cell* const &ffB YS_ATTRIBUTE(unused) = st_ice40_dsp.ffB;
    Cell* const &ffS YS_ATTRIBUTE(unused) = st_ice40_dsp.ffS;
    Cell* const &ffY YS_ATTRIBUTE(unused) = st_ice40_dsp.ffY;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_ice40_dsp.mul;
    Cell* const &muxA YS_ATTRIBUTE(unused) = st_ice40_dsp.muxA;
    Cell* const &muxAB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxAB;
    Cell* const &muxB YS_ATTRIBUTE(unused) = st_ice40_dsp.muxB;
    const SigSpec &sigA YS_ATTRIBUTE(unused) = st_ice40_dsp.sigA;
    const SigSpec &sigB YS_ATTRIBUTE(unused) = st_ice40_dsp.sigB;
    const SigSpec &sigS YS_ATTRIBUTE(unused) = st_ice40_dsp.sigS;
    const SigSpec &sigY YS_ATTRIBUTE(unused) = st_ice40_dsp.sigY;
    SigBit &clock YS_ATTRIBUTE(unused) = st_ice40_dsp.clock;
    bool &clock_pol YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_pol;
    bool &clock_vld YS_ATTRIBUTE(unused) = st_ice40_dsp.clock_vld;

    SigBit backup_clock = clock;
    bool backup_clock_pol = clock_pol;
    bool backup_clock_vld = clock_vld;

    do {
#define reject do { check_blacklist_ice40_dsp(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_ice40_dsp(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_15(); if (rollback) goto rollback_label; } while(0)
      if (ffS) {
        SigBit c = port(ffS, id_b_CLK).as_bit();
        bool cp = param(ffS, id_b_CLK_POLARITY).as_bool();
        if (clock_vld && (c != clock || cp != clock_pol))
          reject;
        clock = c;
        clock_pol = cp;
        clock_vld = true;
      }

      block_15();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    clock = backup_clock;
    clock_pol = backup_clock_pol;
    clock_vld = backup_clock_vld;
  }

  void block_15() {
    on_accept();
    check_blacklist_ice40_dsp();
  }
};
