// Generated by pmgen.py from passes/pmgen/peepopt_shiftmul.pmg
// Generated by pmgen.py from passes/pmgen/peepopt_muldiv.pmg

struct peepopt_pm {
  Module *module;
  SigMap sigmap;
  std::function<void()> on_accept;

  typedef std::tuple<> index_0_key_type;
  dict<index_0_key_type, vector<Cell*>> index_0;
  typedef std::tuple<SigSpec> index_2_key_type;
  dict<index_2_key_type, vector<Cell*>> index_2;
  typedef std::tuple<> index_5_key_type;
  dict<index_5_key_type, vector<Cell*>> index_5;
  typedef std::tuple<SigSpec, SigSpec> index_7_key_type;
  dict<index_7_key_type, vector<Cell*>> index_7;
  dict<SigBit, pool<Cell*>> sigusers;
  pool<Cell*> blacklist_cells;
  pool<Cell*> autoremove_cells;
  bool blacklist_dirty;
  int rollback;

  struct state_muldiv_t {
    Cell* div;
    Cell* mul;
    SigSpec t;
    SigSpec x;
    SigSpec y;
  } st_muldiv;

  struct udata_muldiv_t {
  } ud_muldiv;

  struct state_shiftmul_t {
    Cell* mul;
    SigSpec shamt;
    Cell* shift;
  } st_shiftmul;

  struct udata_shiftmul_t {
  } ud_shiftmul;

  IdString id_b_A{"\\A"};
  IdString id_b_A_SIGNED{"\\A_SIGNED"};
  IdString id_b_A_WIDTH{"\\A_WIDTH"};
  IdString id_b_B{"\\B"};
  IdString id_b_B_SIGNED{"\\B_SIGNED"};
  IdString id_b_B_WIDTH{"\\B_WIDTH"};
  IdString id_b_Y{"\\Y"};
  IdString id_d_div{"$div"};
  IdString id_d_mul{"$mul"};
  IdString id_d_shift{"$shift"};
  IdString id_d_shiftx{"$shiftx"};
  IdString id_d_shr{"$shr"};

  void add_siguser(const SigSpec &sig, Cell *cell) {
    for (auto bit : sigmap(sig)) {
      if (bit.wire == nullptr) continue;
      if (sigusers.count(bit) == 0 && bit.wire->port_id)
        sigusers[bit].insert(nullptr);
      sigusers[bit].insert(cell);
    }
  }

  void blacklist(Cell *cell) {
    if (cell != nullptr) {
      if (blacklist_cells.insert(cell).second)
        blacklist_dirty = true;
    }
  }

  void autoremove(Cell *cell) {
    if (cell != nullptr) {
      if (blacklist_cells.insert(cell).second)
        blacklist_dirty = true;
      autoremove_cells.insert(cell);
    }
  }

  void check_blacklist_muldiv() {
    if (!blacklist_dirty)
      return;
    blacklist_dirty = false;
    if (st_muldiv.mul != nullptr && blacklist_cells.count(st_muldiv.mul)) {
      rollback = 6;
      return;
    }
    if (st_muldiv.div != nullptr && blacklist_cells.count(st_muldiv.div)) {
      rollback = 8;
      return;
    }
    rollback = 0;
  }

  void check_blacklist_shiftmul() {
    if (!blacklist_dirty)
      return;
    blacklist_dirty = false;
    if (st_shiftmul.shift != nullptr && blacklist_cells.count(st_shiftmul.shift)) {
      rollback = 1;
      return;
    }
    if (st_shiftmul.mul != nullptr && blacklist_cells.count(st_shiftmul.mul)) {
      rollback = 3;
      return;
    }
    rollback = 0;
  }

  SigSpec port(Cell *cell, IdString portname) {
    return sigmap(cell->getPort(portname));
  }

  Const param(Cell *cell, IdString paramname) {
    return cell->getParam(paramname);
  }

  int nusers(const SigSpec &sig) {
    pool<Cell*> users;
    for (auto bit : sigmap(sig))
      for (auto user : sigusers[bit])
        users.insert(user);
    return GetSize(users);
  }

  peepopt_pm(Module *module, const vector<Cell*> &cells) :
      module(module), sigmap(module) {
    for (auto cell : module->cells()) {
      for (auto &conn : cell->connections())
        add_siguser(conn.second, cell);
    }
    for (auto cell : cells) {
      do {
        Cell *shift = cell;
        if (!(shift->type.in(id_d_shift, id_d_shiftx, id_d_shr))) break;
        index_0_key_type key;
        index_0[key].push_back(cell);
      } while (0);
      do {
        Cell *mul = cell;
        if (!(mul->type.in(id_d_mul))) break;
        if (!(port(mul, id_b_A).is_fully_const() || port(mul, id_b_B).is_fully_const())) break;
        index_2_key_type key;
        std::get<0>(key) = port(mul, id_b_Y);
        index_2[key].push_back(cell);
      } while (0);
      do {
        Cell *mul = cell;
        if (!(mul->type == id_d_mul)) break;
        if (!(GetSize(port(mul, id_b_A)) + GetSize(port(mul, id_b_B)) <= GetSize(port(mul, id_b_Y)))) break;
        index_5_key_type key;
        index_5[key].push_back(cell);
      } while (0);
      do {
        Cell *div = cell;
        if (!(div->type.in(id_d_div))) break;
        index_7_key_type key;
        std::get<0>(key) = port(div, id_b_A);
        std::get<1>(key) = port(div, id_b_B);
        index_7[key].push_back(cell);
      } while (0);
    }
  }

  ~peepopt_pm() {
    for (auto cell : autoremove_cells)
      module->remove(cell);
  }

  void run_muldiv(std::function<void()> on_accept_f) {
    on_accept = on_accept_f;
    rollback = 0;
    blacklist_dirty = false;
    st_muldiv.div = nullptr;
    st_muldiv.mul = nullptr;
    st_muldiv.t = SigSpec();
    st_muldiv.x = SigSpec();
    st_muldiv.y = SigSpec();
    block_5();
  }

  void run_muldiv(std::function<void(peepopt_pm&)> on_accept_f) {
    run_muldiv([&](){on_accept_f(*this);});
  }

  void run_muldiv(std::function<void(state_muldiv_t&)> on_accept_f) {
    run_muldiv([&](){on_accept_f(st_muldiv);});
  }

  void run_muldiv() {
    run_muldiv([](){});
  }

  void run_shiftmul(std::function<void()> on_accept_f) {
    on_accept = on_accept_f;
    rollback = 0;
    blacklist_dirty = false;
    st_shiftmul.mul = nullptr;
    st_shiftmul.shamt = SigSpec();
    st_shiftmul.shift = nullptr;
    block_0();
  }

  void run_shiftmul(std::function<void(peepopt_pm&)> on_accept_f) {
    run_shiftmul([&](){on_accept_f(*this);});
  }

  void run_shiftmul(std::function<void(state_shiftmul_t&)> on_accept_f) {
    run_shiftmul([&](){on_accept_f(st_shiftmul);});
  }

  void run_shiftmul() {
    run_shiftmul([](){});
  }

  void block_0() {
    Cell* &shift YS_ATTRIBUTE(unused) = st_shiftmul.shift;

    index_0_key_type key;
    const vector<Cell*> &cells = index_0[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      shift = cells[idx];
      if (blacklist_cells.count(shift)) continue;
      block_1();
      if (rollback) {
        if (rollback != 1) {
          shift = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    shift = nullptr;
  }

  void block_1() {
    Cell* const &shift YS_ATTRIBUTE(unused) = st_shiftmul.shift;
    SigSpec &shamt YS_ATTRIBUTE(unused) = st_shiftmul.shamt;

    do {
#define reject do { check_blacklist_shiftmul(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_shiftmul(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_2(); if (rollback) goto rollback_label; } while(0)
      shamt = port(shift, id_b_B);
      if (shamt.empty())
        reject;
      if (shamt[GetSize(shamt)-1] == State::S0) {
        do {
          shamt.remove(GetSize(shamt)-1);
          if (shamt.empty())
            reject;
        } while (shamt[GetSize(shamt)-1] == State::S0);
      } else
      if (shift->type.in(id_d_shift, id_d_shiftx) && param(shift, id_b_B_SIGNED).as_bool()) {
        reject;
      }
      if (GetSize(shamt) > 20)
        reject;

      block_2();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    shamt = SigSpec();
  }

  void block_2() {
    const SigSpec &shamt YS_ATTRIBUTE(unused) = st_shiftmul.shamt;
    Cell* const &shift YS_ATTRIBUTE(unused) = st_shiftmul.shift;
    Cell* &mul YS_ATTRIBUTE(unused) = st_shiftmul.mul;

    index_2_key_type key;
    std::get<0>(key) = shamt;
    const vector<Cell*> &cells = index_2[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      mul = cells[idx];
      if (blacklist_cells.count(mul)) continue;
      block_3();
      if (rollback) {
        if (rollback != 3) {
          mul = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    mul = nullptr;
  }

  void block_3() {
    Cell* const &mul YS_ATTRIBUTE(unused) = st_shiftmul.mul;
    const SigSpec &shamt YS_ATTRIBUTE(unused) = st_shiftmul.shamt;
    Cell* const &shift YS_ATTRIBUTE(unused) = st_shiftmul.shift;

    do {
#define reject do { check_blacklist_shiftmul(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_shiftmul(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_4(); if (rollback) goto rollback_label; } while(0)
      IdString const_factor_port = port(mul, id_b_A).is_fully_const() ? id_b_A : id_b_B;
      IdString const_factor_signed = const_factor_port == id_b_A ? id_b_A_SIGNED : id_b_B_SIGNED;
      Const const_factor_cnst = port(mul, const_factor_port).as_const();
      int const_factor = const_factor_cnst.as_int();
      if (GetSize(const_factor_cnst) == 0)
        reject;
      if (const_factor_cnst.bits[GetSize(const_factor_cnst)-1] != State::S0 &&
          param(mul, const_factor_signed).as_bool())
        reject;
      if (GetSize(const_factor_cnst) > 20)
        reject;
      if (GetSize(port(shift, id_b_Y)) > const_factor)
        reject;
      int factor_bits = ceil_log2(const_factor);
      SigSpec mul_din = port(mul, const_factor_port == id_b_A ? id_b_B : id_b_A);
      if (GetSize(shamt) < factor_bits+GetSize(mul_din))
        reject;
      did_something = true;
      log("shiftmul pattern in %s: shift=%s, mul=%s\n", log_id(module), log_id(shift), log_id(mul));
      int new_const_factor = 1 << factor_bits;
      SigSpec padding(State::Sx, new_const_factor-const_factor);
      SigSpec old_a = port(shift, id_b_A), new_a;
      int trunc = 0;
      if (GetSize(old_a) % const_factor != 0) {
        trunc = const_factor - GetSize(old_a) % const_factor;
        old_a.append(SigSpec(State::Sx, trunc));
      }
      for (int i = 0; i*const_factor < GetSize(old_a); i++) {
        SigSpec slice = old_a.extract(i*const_factor, const_factor);
        new_a.append(slice);
        new_a.append(padding);
      }
      if (trunc > 0)
        new_a.remove(GetSize(new_a)-trunc, trunc);
      SigSpec new_b = {mul_din, SigSpec(State::S0, factor_bits)};
      if (param(shift, id_b_B_SIGNED).as_bool())
        new_b.append(State::S0);
      shift->setPort(id_b_A, new_a);
      shift->setParam(id_b_A_WIDTH, GetSize(new_a));
      shift->setPort(id_b_B, new_b);
      shift->setParam(id_b_B_WIDTH, GetSize(new_b));
      blacklist(shift);
      reject;

      block_4();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);
  }

  void block_4() {
    on_accept();
    check_blacklist_shiftmul();
  }

  void block_5() {
    Cell* &mul YS_ATTRIBUTE(unused) = st_muldiv.mul;

    index_5_key_type key;
    const vector<Cell*> &cells = index_5[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      mul = cells[idx];
      if (blacklist_cells.count(mul)) continue;
      block_6();
      if (rollback) {
        if (rollback != 6) {
          mul = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    mul = nullptr;
  }

  void block_6() {
    Cell* const &mul YS_ATTRIBUTE(unused) = st_muldiv.mul;
    SigSpec &t YS_ATTRIBUTE(unused) = st_muldiv.t;
    SigSpec &x YS_ATTRIBUTE(unused) = st_muldiv.x;
    SigSpec &y YS_ATTRIBUTE(unused) = st_muldiv.y;

    do {
#define reject do { check_blacklist_muldiv(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_muldiv(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_7(); if (rollback) goto rollback_label; } while(0)
      t = port(mul, id_b_Y);
      x = port(mul, id_b_A);
      y = port(mul, id_b_B);
      branch;
      std::swap(x, y);

      block_7();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);

    t = SigSpec();
    x = SigSpec();
    y = SigSpec();
  }

  void block_7() {
    Cell* const &mul YS_ATTRIBUTE(unused) = st_muldiv.mul;
    const SigSpec &t YS_ATTRIBUTE(unused) = st_muldiv.t;
    const SigSpec &x YS_ATTRIBUTE(unused) = st_muldiv.x;
    const SigSpec &y YS_ATTRIBUTE(unused) = st_muldiv.y;
    Cell* &div YS_ATTRIBUTE(unused) = st_muldiv.div;

    index_7_key_type key;
    std::get<0>(key) = t;
    std::get<1>(key) = x;
    const vector<Cell*> &cells = index_7[key];

    for (int idx = 0; idx < GetSize(cells); idx++) {
      div = cells[idx];
      if (blacklist_cells.count(div)) continue;
      block_8();
      if (rollback) {
        if (rollback != 8) {
          div = nullptr;
          return;
        }
        rollback = 0;
      }
    }

    div = nullptr;
  }

  void block_8() {
    Cell* const &div YS_ATTRIBUTE(unused) = st_muldiv.div;
    Cell* const &mul YS_ATTRIBUTE(unused) = st_muldiv.mul;
    const SigSpec &t YS_ATTRIBUTE(unused) = st_muldiv.t;
    const SigSpec &x YS_ATTRIBUTE(unused) = st_muldiv.x;
    const SigSpec &y YS_ATTRIBUTE(unused) = st_muldiv.y;

    do {
#define reject do { check_blacklist_muldiv(); goto rollback_label; } while(0)
#define accept do { on_accept(); check_blacklist_muldiv(); if (rollback) goto rollback_label; } while(0)
#define branch do { block_9(); if (rollback) goto rollback_label; } while(0)
      SigSpec div_y = port(div, id_b_Y);
      SigSpec val_y = y;
      if (GetSize(div_y) != GetSize(val_y))
        val_y.extend_u0(GetSize(div_y), param(div, id_b_A_SIGNED).as_bool());
      did_something = true;
      log("muldiv pattern in %s: mul=%s, div=%s\n", log_id(module), log_id(mul), log_id(div));
      module->connect(div_y, val_y);
      autoremove(div);
      reject;

      block_9();
#undef reject
#undef accept
#undef branch
    } while (0);

rollback_label:
    YS_ATTRIBUTE(unused);
  }

  void block_9() {
    on_accept();
    check_blacklist_muldiv();
  }
};
